/*  Time-stamp: <2004-05-11 15:41:15 >  */
#include  "NOTEfile.h"
#include  "rm_dquote.h"


int NOTEheader_write(FILE *fp, NOTE_HEADER header_info,
		     int beattime_flag, int prec, int smf_divi)
{

  fprintf(fp, "Header {\n");

  rm_dquote(header_info.title);
  if(strcmp(header_info.title, "") != 0){
    fprintf(fp, "  TITLE \"%s\"\n", header_info.title);
  }

  rm_dquote(header_info.composer);
  if(strcmp(header_info.composer, "") != 0){
    fprintf(fp, "  COMPOSER \"%s\"\n", header_info.composer);
  }

  rm_dquote(header_info.performer);
  if(strcmp(header_info.performer, "") != 0){
    fprintf(fp, "  PERFORMER \"%s\"\n", header_info.performer);
  }

  rm_dquote(header_info.accompanist);
  if(strcmp(header_info.accompanist, "") != 0){
    fprintf(fp, "  ACCOMPANIST \"%s\"\n", header_info.accompanist);
  }

  rm_dquote(header_info.arranger);
  if(strcmp(header_info.arranger, "") != 0){
    fprintf(fp, "  ARRANGER \"%s\"\n", header_info.arranger);
  }

  rm_dquote(header_info.generator);
  if(strcmp(header_info.generator, "") != 0){
    fprintf(fp, "  GENERATOR \"%s\"\n", header_info.generator);
  }

  switch(header_info.timescale){
  case  T_REAL:
    fprintf(fp, "  TIMESCALE  Real\n");
    break;
    
  case  T_DELTA:
    fprintf(fp, "  TIMESCALE  Delta %d\n", smf_divi);
    break;
    
  case  T_BEAT:
  default:
    fprintf(fp, "  TIMESCALE  Beat\n");
    break;
  }
  
  if(header_info.beat_bunsi > 0.0){
    fprintf(fp, "  BEAT %d / %d\n", 
	    header_info.beat_bunsi, header_info.beat_bunbo);
  }

  if(header_info.tactus > 0.0){
    fprintf(fp, "  TACTUS %d\n", header_info.tactus);
  }

  if(header_info.bpm > 0.0){
    if(beattime_flag == ON){
      if(header_info.timescale == T_DELTA){
	fprintf(fp, "  BEATTIME %1.*f %d\n\n",
		prec,
		60000.0 / header_info.bpm,
		smf_divi);
      }else{
	fprintf(fp, "  BEATTIME %1.*f 4\n\n",
		prec,
		60000.0 / header_info.bpm);
      }
    }else{
      if(header_info.timescale == T_DELTA){
	fprintf(fp, "  BPM %4.1f %d\n", header_info.bpm, smf_divi);
      }else{
	fprintf(fp, "  BPM %4.1f %d\n", header_info.bpm, 4);
      }
    }
  }

#ifdef OLD
  fprintf(fp, "EXP ON\n");
  fprintf(fp, "VL ON\n");
  fprintf(fp, "LENGTH_EXP ON\n");
#endif
  
  fprintf(fp, "}\n\n");
  

  return EXIT_SUCCESS;
}


