/*  Time-stamp: <2005-04-19 16:34:54 >  */
#include  "NOTEfile.h"
#ifndef stricmp
#include  "stricmp.h"
#endif

#include  "disp_errline.h"

#define  READED 1


extern NOTE_NODE *note_bot;
extern NOTE_NODE *note_cur;
extern NOTE_NODE *note_alc;



NOTE_NODE *NOTEfile_read(char *filename, NOTE_HEADER *header_info, DRUM_DEF *drum_data)
{
  FILE *fp;
  char linebuf[READBUF_LEN];
  char token[READBUF_LEN];
  char err_mesg[READBUF_LEN];
  int line;
  int idx;
  NOTE_NODE *top = NULL;
  NOTE_NODE *cur = NULL;
  NOTE_NODE *same = NULL;
  double now_on_time;


  if(filename == NULL){
    open_note_midi_input();
    return  NULL;
  }


  fp = fopen(filename, "r");
  if(fp == NULL){
    fprintf(stderr, "Can't open file %s.\n", filename);
    exit(EXIT_FAILURE);
  }

  line = 0;  /*  äʤ褦  */


  /*  "Header" õ */
  while(1){
    if(fgetline(linebuf, READBUF_LEN, fp, &line, &idx) == NULL){
      disp_errline(filename, line, linebuf, idx, "ե뤬ԴǤ(ǽäƤ롩)");
      fclose(fp);
      exit(EXIT_FAILURE);
      break;
    }

    get_token(linebuf, &idx, token);

    if(stricmp(token, "Header") == 0){
      break;
    }else if(stricmp(token, "") == 0){  /*  ԤäɤФ  */
      continue;
    }else if(stricmp(token, " ") == 0){  /*  ʸƬˤԤɤФ  */
      get_token(linebuf, &idx, token);
      if(stricmp(token, "") == 0){  /*  EOL -> Գ  */
	continue;  /*  ⤷ʤǡιԤؿʤ  */
      }else if(token[0] == '%'){  /*  token ==   */
	get_token(linebuf, &idx, token);
	if(stricmp(token, "") == 0){  /*  EOL -> ȹԳ  */
	  continue;  /*  ⤷ʤǡιԤؿʤ  */
	}else{
	  disp_errline(filename, line, linebuf, idx, "ȹԤβʸ۾");
	  fclose(fp);
	  exit(EXIT_FAILURE);
	}
      }else{
	disp_errline(filename, line, linebuf, idx, "Header ˥Ȱʳʸ񤫤Ƥ롩");
	fclose(fp);
	exit(EXIT_FAILURE);
      }
    }else if(token[0] == '%'){  /*  ȹԤɤФ  */
	get_token(linebuf, &idx, token);
	if(stricmp(token, "") == 0){  /*  EOL -> ȹԳ  */
	  continue;  /*  ⤷ʤǡιԤؿʤ  */
	}else{
	  disp_errline(filename, line, linebuf, idx, "ȹԤβʸ۾");
	  fclose(fp);
	  exit(EXIT_FAILURE);
	}
    }else{
      disp_errline(filename, line, linebuf, idx, "Header ˥Ȱʳʸ񤫤Ƥ롩");
      fclose(fp);
      exit(EXIT_FAILURE);
    }
  }

  /*------ إå ------*/
  /*
    Header [ʸ]... { [ʸ]... [] ʸ
    
  */
  get_token(linebuf, &idx, token);
  if(stricmp(token, " ") == 0){
    get_token(linebuf, &idx, token);
  }

  if(stricmp(token, "{") != 0){  /*  "{" 뤫å  */
    disp_errline(filename, line, linebuf, idx, " Header θ \"{\" ʤ");
    fclose(fp);
    exit(EXIT_FAILURE);
  }

  /*  "{" ʹߡԤޤɤФ  */
  get_token(linebuf, &idx, token);
  if(stricmp(token, " ") == 0){  /*  ʸɤФ  */
    get_token(linebuf, &idx, token);
  }

  if(token[0] == '%'){  /*  ȤɤФ  */
    get_token(linebuf, &idx, token);
  }

  if(stricmp(token, "") != 0){  /*  ʸʳʸ롩  */
    disp_errline(filename, line, linebuf, idx, "\"{\" ʹߤˡȰʳʸ롩");
    fclose(fp);
    exit(EXIT_FAILURE);
  }

  /*  إåȲϳ  */
  while(1){
    if(fgetline(linebuf, READBUF_LEN, fp, &line, &idx) == NULL){
      disp_errline(filename, line, linebuf, idx, "ե뤬ԴǤ(ǽäƤ롩)");
      fclose(fp);
      exit(EXIT_FAILURE);
      break;
    }

    get_token(linebuf, &idx, token);
    if(stricmp(token, " ") == 0){  /*  ʸɤФ  */
      get_token(linebuf, &idx, token);
    }

    if(token[0] == '%'){  /*  ȹ  */
      /*
      note_comment_parse(fp, filename, line, linebuf, &idx, token, cur);
      */
      get_token(linebuf, &idx, token);
    }else if(stricmp(token, "BEAT") == 0){  /*  BEAT ɤβ  */
      note_beat_parse(fp, filename, line, linebuf, &idx, token, header_info, NULL);
    }else if(stricmp(token, "BPM") == 0){  /*  BPM ɤβ  */
      note_bpm_parse(fp, filename, line, linebuf, &idx, token, header_info, NULL, HEADER);
    }else if(stricmp(token, "BEATTIME") == 0){  /*  BEATTIME ɤβ  */
      note_beattime_parse(fp, filename, line, linebuf, &idx, token, header_info, NULL, HEADER);
    }else if(stricmp(token, "TACTUS") == 0){  /*  TACTUS ɤβ  */
      note_tactus_parse(fp, filename, line, linebuf, &idx, token, header_info, NULL);
    }else if(stricmp(token, "TIMESCALE") == 0){  /*  TIMESCALE ɤβ  */
      note_timescale_parse(fp, filename, line, linebuf, &idx, token, header_info, NULL);
    }else if(stricmp(token, "TITLE") == 0){  /*  TITLE ɤβ  */
      note_title_parse(fp, filename, line, linebuf, &idx, token, header_info, NULL);
    }else if(stricmp(token, "COMPOSER") == 0){  /*  COMPOSER ɤβ  */
      note_composer_parse(fp, filename, line, linebuf, &idx, token, header_info, NULL);
    }else if(stricmp(token, "PERFORMER") == 0){  /*  PERFORMER ɤβ  */
      note_performer_parse(fp, filename, line, linebuf, &idx, token, header_info, NULL);
    }else if(stricmp(token, "ACCOMPANIST") == 0){  /*  ACCOMPANIST ɤβ  */
      note_accompanist_parse(fp, filename, line, linebuf, &idx, token, header_info, NULL);
    }else if(stricmp(token, "ARRANGER") == 0){  /*  ARRANGER ɤβ  */
      note_arranger_parse(fp, filename, line, linebuf, &idx, token, header_info, NULL);
    }else if(stricmp(token, "GENERATOR") == 0){  /*  GENERATOR ɤβ  */
      note_generator_parse(fp, filename, line, linebuf, &idx, token, header_info, NULL);
    }else if(stricmp(token, "}") == 0){  /*  إåνλǧ  */
      get_token(linebuf, &idx, token);
      /*   [ʸ]... [] ʸ ν  */
      if(stricmp(token, " ") == 0){
	get_token(linebuf, &idx, token);
      }
      if(token[0] == '%'){  /*  ³  */
	get_token(linebuf, &idx, token);
      }
      if(stricmp(token, "") != 0){
	disp_errline(filename, line, linebuf, idx, "ʸ۾");
	printf("%2x\n", token[0]);
	printf("%s\n", token);
	fclose(fp);
	exit(EXIT_FAILURE);
      }

      break;  /*  إåϥ롼׽λ(æ)  */
    }else if(stricmp(token, "") == 0){  /*    */
      ; /*  ʤˤ⤷ʤ  */
    }else{
      sprintf(err_mesg, jcode_local("إå˵ҤǤʤ \"%s\" 롥ʶζ˺졩"), token);
      disp_errline(filename, line, linebuf, idx, err_mesg);
      fclose(fp);
      exit(EXIT_FAILURE);
    }

    if(token[0] == '%'){  /*  ³  */
      get_token(linebuf, &idx, token);
    }


    /*   [ʸ]... [] ʸ ν  */
    if(stricmp(token, " ") == 0){
      get_token(linebuf, &idx, token);
    }

    if(token[0] == '%'){  /*  ³  */
      get_token(linebuf, &idx, token);
    }

    if(stricmp(token, "") != 0){
      disp_errline(filename, line, linebuf, idx, "ʸ۾");
      printf("%2x\n", token[0]);
      printf("%s\n", token);
      fclose(fp);
      exit(EXIT_FAILURE);
    }
  }

  /*
  br_printf(-1, "\n------ إåϽλ ------\n");
  */

  /*  ܥǥβ  */
  /*
  br_printf(-1, "\n------ ܥǥϳ ------\n");
  */

  top = NOTE_NODE_alloc();
  now_on_time = 0.0;
  cur = top;
  while(1){
    if(fgetline(linebuf, READBUF_LEN, fp, &line, &idx) == NULL){
      fclose(fp);
      cur = cur_postproc(cur);
      break;
    }

    get_token(linebuf, &idx, token);
    if(stricmp(token, " ") == 0){  /*  ʸɤФ  */
      get_token(linebuf, &idx, token);
    }

    if(token[0] == '%'){  /*  ȹ  */
      get_token(linebuf, &idx, token);
    }else if(strcmp(token, "=") == 0){
      note_bar_parse(fp, filename, line, linebuf, &idx, token, cur);
      set_on_time(fp, header_info, cur, now_on_time);
      if(header_info->timescale == NO_INFO){
	header_info->timescale = T_MEAS;
      }
      cur = NOTE_next_NODE_alloc(cur);
    }else if(stricmp(token, "") == 0){  /*    */
      ;  /*  ⤷ʤ  */
    }else if(note_s_time_parse(fp, filename, line, linebuf, &idx, token, header_info, cur) == 0){/*  Ȼ  */
      now_on_time = get_on_time(fp, header_info, cur);
      get_token(linebuf, &idx, token);  /*  ʸɤФ  */
      if(stricmp(token, " ") != 0){
	disp_errline(filename, line, linebuf, idx, "Ȼľ˶ʸʤ");
	fclose(fp);
	exit(EXIT_FAILURE);
      }
      get_token(linebuf, &idx, token);
      if(strcmp(token, "(") == 0){  /*  䡤β  */
	same = cur;
	while(1){
	  note_noterest_parse(fp, filename, line, linebuf, &idx, token, header_info, same, drum_data);
	  same = NOTE_samenext_NODE_alloc(same);
	  if(stricmp(token, " ") == 0){
	    get_token(linebuf, &idx, token);  /*  ʸɤФ  */
	  }
	  if(stricmp(token, "") == 0){  /*    */
	    same = same_postproc(same);
	    break;
	  }
	  if(token[0] == '%'){  /*  ³  */
	    same = same_postproc(same);
	    break;  /*   break ƲΤۤˤ³ȽǤ  */
	  }
	}
	cur = NOTE_next_NODE_alloc(cur);
      }else if(strcmp(token, "!") == 0){
	note_memo_parse(fp, filename, line, linebuf, &idx, token, cur);
	cur = NOTE_next_NODE_alloc(cur);
      }else if(stricmp(token, "TIMESHIFT") == 0){
	note_timeshift_parse(fp, filename, line, linebuf, &idx, token, NULL, cur);
	cur = NOTE_next_NODE_alloc(cur);
      }else if(stricmp(token, "BEAT") == 0){  /*  BEAT ɤβ  */
	note_beat_parse(fp, filename, line, linebuf, &idx, token, NULL, cur);
	cur = NOTE_next_NODE_alloc(cur);
      }else if(stricmp(token, "BPM") == 0){  /*  BPM ɤβ  */
	note_bpm_parse(fp, filename, line, linebuf, &idx, token, NULL, cur, BODY);
	cur = NOTE_next_NODE_alloc(cur);
      }else if(stricmp(token, "BEATTIME") == 0){  /*  BEATTIME ɤβ  */
	note_beattime_parse(fp, filename, line, linebuf, &idx, token, NULL, cur, BODY);
	cur = NOTE_next_NODE_alloc(cur);
      }else if(stricmp(token, "TACTUS") == 0){  /*  TACTUS ɤβ  */
	note_tactus_parse(fp, filename, line, linebuf, &idx, token, NULL, cur);
	cur = NOTE_next_NODE_alloc(cur);
      }else if(stricmp(token, "TIMESCALE") == 0){  /*  TIMESCALE ɤβ  */
	note_timescale_parse(fp, filename, line, linebuf, &idx, token, NULL, cur);
	cur = NOTE_next_NODE_alloc(cur);
      }else if(stricmp(token, "TITLE") == 0){  /*  TITLE ɤβ  */
	note_title_parse(fp, filename, line, linebuf, &idx, token, NULL, cur);
	cur = NOTE_next_NODE_alloc(cur);
      }else if(stricmp(token, "COMPOSER") == 0){  /*  COMPOSER ɤβ  */
	note_composer_parse(fp, filename, line, linebuf, &idx, token, NULL, cur);
	cur = NOTE_next_NODE_alloc(cur);
      }else if(stricmp(token, "PERFORMER") == 0){  /*  PERFORMER ɤβ  */
	note_performer_parse(fp, filename, line, linebuf, &idx, token, NULL, cur);
	cur = NOTE_next_NODE_alloc(cur);
      }else if(stricmp(token, "ACCOMPANIST") == 0){  /*  ACCOMPANIST ɤβ  */
	note_accompanist_parse(fp, filename, line, linebuf, &idx, token, NULL, cur);
	cur = NOTE_next_NODE_alloc(cur);
      }else if(stricmp(token, "ARRANGER") == 0){  /*  ARRANGER ɤβ  */
	note_arranger_parse(fp, filename, line, linebuf, &idx, token, NULL, cur);
	cur = NOTE_next_NODE_alloc(cur);
      }else if(stricmp(token, "GENERATOR") == 0){  /*  GENERATOR ɤβ  */
	note_generator_parse(fp, filename, line, linebuf, &idx, token, NULL, cur);
	cur = NOTE_next_NODE_alloc(cur);
      }else if(
	       (stricmp(token, "Damper") == 0) ||
	       (stricmp(token, "Sostenuto") == 0) ||
	       (stricmp(token, "Soft") == 0) ){
	note_pedal_parse(fp, filename, line, linebuf, &idx, token, NULL, cur);
	cur = NOTE_next_NODE_alloc(cur);
      }else if(stricmp(token, "PAUSE") == 0){
	note_pause_parse(fp, filename, line, linebuf, &idx, token, NULL, cur);
	cur = NOTE_next_NODE_alloc(cur);
      }else if(stricmp(token, "MIDI") == 0){
	note_MIDI_parse(fp, filename, line, linebuf, &idx, token, NULL, cur);
	cur = NOTE_next_NODE_alloc(cur);
      }else{
	sprintf(err_mesg, jcode_local("Τ̵һ \"%s\"Ǥ"), token);
	disp_errline(filename, line, linebuf, idx, err_mesg);
	fclose(fp);
	exit(EXIT_FAILURE);
      }
    }else if(stricmp(token, "END") == 0){
      cur = cur_postproc(cur);
      note_bot = cur;
      break;
    }


    /*  ζʸʸν  */
    if(stricmp(token, " ") == 0){
      get_token(linebuf, &idx, token);
    }

    if(token[0] == '%'){  /*  ³  */
	get_token(linebuf, &idx, token);
    }

    if(stricmp(token, "") != 0){
      sprintf(err_mesg, jcode_local("ʸޤǤδ֤;פʸ \"%s\" (%2x) 롩"), token, token[0]);
      disp_errline(filename, line, linebuf, idx, err_mesg);
      fclose(fp);
      exit(EXIT_FAILURE);
    }
  }

/* Time-stamp: <2005-02-08 15:37:31 >  */
/*   printf("\n"); */

  note_time_consistency(top, header_info);  /*  T_BEAT, T_MEAN, T_REAL, T_DELTA  Τɤ줫ˡ
						     ľ  */

  /*  TIMESHIFT   */
  note_timeshift(&top);


#if 0
  cur = top;
  while(1){
    if(cur == NULL){  break; }
    printf("%5.3f: %d\n", cur->on_time.beat, cur->ident);
    cur = cur->next;

  }
#endif

#if 0
  br_printf(8, "ϡޤ koko\n");
  fclose(fp);
  exit(0);
#endif

  return top;
}
