/* Time-stamp: <2005-08-16 01:09:40 >  */
#include  "4ru.h"


void apply_devi(NOTE_NODE *t_s, NOTE_NODE *t_e, NOTE_NODE *c_s, NOTE_NODE *c_e, PERF_CTRL pctrl)
{
  NOTE_NODE *t_cur = NULL;
  NOTE_NODE *c_cur = NULL;
  NOTE_NODE *t_same = NULL;
  NOTE_NODE *c_same = NULL;
  NOTE_NODE *t_n_s = NULL;
  NOTE_NODE *t_n_e = NULL;
  NOTE_NODE *c_n_s = NULL;
  NOTE_NODE *c_n_e = NULL;
  NOTE_NODE *ins_tmp = NULL;
  NOTE_NODE *c_n_s_pre_note = NULL;
  NOTE_NODE *t_n_s_pre_note = NULL;
  double c_top_qbeattime;
  double c_now_qbeattime;
  double t_top_qbeattime;
  double t_now_qbeattime;
  double t_len;
  double c_len;
  double c_t_rate;
  double c_now_time;
  double t_top_time;
  double t_now_time;
  double c_pre_vel;
  double t_pre_vel;



/*   puts("====== TARGET ======"); */
/*   notelist_display_fromto(t_s, t_e); */

  t_cur = t_s;
  while(1){
    if(t_cur == NULL){  return; }
    if(t_cur->ident == NOTE){
      t_n_s = t_cur;
      break;
    }
    t_cur = t_cur->next;
  }

  while(1){
    if(t_cur == NULL){  break; }
    if(t_cur->ident == NOTE){
      t_n_e = t_cur;
    }
    if(t_cur == t_e){  break; }
    t_cur = t_cur->next;
  }


  c_cur = c_s;
  while(1){
    if(c_cur == NULL){  return; }
    if(c_cur->ident == NOTE){
      c_n_s = c_cur;
      break;
    }
    c_cur = c_cur->next;
  }

  while(1){
    if(c_cur == NULL){  break; }
    if(c_cur->ident == NOTE){
      c_n_e = c_cur;
    }
    if(c_cur == c_e){  break; }
    c_cur = c_cur->next;
  }

/*   br_printf(6, "====== target ======\n"); */
/*   notelist_display_fromto(t_n_s, t_n_e); */

/*   br_printf(7, "====== corpus ======\n"); */
/*   notelist_display_fromto(c_n_s, c_n_e); */


  t_len = t_n_e->on_time.beat - t_n_s->on_time.beat;
  c_len = c_n_e->on_time.beat - c_n_s->on_time.beat;
  c_t_rate = t_len / c_len;
/*   br_printf(4, "rate: %f\n", c_t_rate); */
/*   exit(0); */


  /*  TARGET Ƭ Damper ղä  */
  c_cur = c_n_s;
  while(1){
    if(c_cur == NULL){  break; }
    if(c_cur->ident == DAMPER){
      ins_tmp = NOTE_NODE_alloc();
      memmove(ins_tmp, c_cur, sizeof(*c_cur));
      ins_tmp->pre = NULL;
      ins_tmp->next = NULL;
      ins_tmp->samepre = NULL;
      ins_tmp->samenext = NULL;

      ins_node_pre(t_n_s, ins_tmp);
      TFcopy( &(t_n_s->pre->on_time), &(t_n_s->on_time) );
      break;
    }
    c_cur = c_cur->pre;
  }


  /*  TARGET  Damper ղä  */
  c_cur = c_n_e;
  while(1){
    if(c_cur == NULL){  break; }
    if(c_cur->ident == DAMPER){
      ins_tmp = NOTE_NODE_alloc();
      memmove(ins_tmp, c_cur, sizeof(*c_cur));
      ins_tmp->pre = NULL;
      ins_tmp->next = NULL;
      ins_tmp->samepre = NULL;
      ins_tmp->samenext = NULL;

      ins_node_after(t_n_e, ins_tmp);
      TFcopy( &(t_n_e->next->on_time), &(t_n_e->on_time) );
      break;
    }
    c_cur = c_cur->next;
  }

  /*  TARGET  ƥݾ  */
  /*  corpus Ƭ beattime   */
  c_top_qbeattime = get_top_beattime(c_n_s);

  if(c_top_qbeattime > 0){
    t_top_qbeattime = get_top_beattime(t_n_s);
    br_printf(5, "%f: %f\n", c_top_qbeattime, t_top_qbeattime);
    if(t_top_qbeattime < 0){
      t_top_qbeattime = c_top_qbeattime;
      ins_tmp = NOTE_NODE_alloc();
      ins_tmp->pre = NULL;
      ins_tmp->next = NULL;
      ins_tmp->samepre = NULL;
      ins_tmp->samenext = NULL;
      ins_tmp->val[0] = t_top_qbeattime;
      ins_tmp->val[1] = 16;  /*  ʬ  */
      ins_tmp->ident = BEATTIME;

      ins_node_pre(t_n_s, ins_tmp);
      TFcopy( &(t_n_s->pre->on_time), &(t_n_s->on_time) );
    }
    t_now_qbeattime = t_top_qbeattime;
    c_now_qbeattime = c_top_qbeattime;

    t_cur = t_n_s;
    c_cur = c_n_s;
    t_top_time = t_n_s->on_time.beat;

    while(1){
      if(c_cur == NULL){  break; }
      if( (c_cur->ident == BEATTIME) || (c_cur->ident == BPM) ){
	if(c_cur->ident == BEATTIME){
	  c_now_qbeattime = calc_qbeattime(c_cur->val[0], c_cur->val[1], -1, -1);
	}
	else if(c_cur->ident == BPM){
	  c_now_qbeattime = calc_qbeattime(-1, -1, c_cur->val[0], c_cur->val[1]);
	}
/* 	t_now_qbeattime = t_top_qbeattime + (c_now_qbeattime - c_top_qbeattime); */
	t_now_qbeattime = t_top_qbeattime * (c_now_qbeattime / c_top_qbeattime);
	c_now_time = c_cur->on_time.beat - c_n_s->on_time.beat;
/* 	br_printf(5, "%5.3f: %f\n", c_now_time, t_now_qbeattime); */
	br_printf(5, "%f: %f -> %f: %f\n", c_top_qbeattime, c_now_qbeattime, t_top_qbeattime, t_now_qbeattime);

	t_cur = t_n_s;
	while(1){
	  if(t_cur == NULL){  break; }
	  t_now_time = t_cur->on_time.beat - t_top_time;
	  if( (t_cur->ident == NOTE) && (c_now_time <= t_now_time) ){
	    ins_tmp = NOTE_NODE_alloc();
	    ins_tmp->pre = NULL;
	    ins_tmp->next = NULL;
	    ins_tmp->samepre = NULL;
	    ins_tmp->samenext = NULL;
	    ins_tmp->val[0] = t_now_qbeattime;
	    ins_tmp->val[1] = 16;  /*  ʬ  */
	    ins_tmp->ident = BEATTIME;

	    ins_node_pre(t_cur, ins_tmp);
	    TFcopy( &(t_cur->pre->on_time), &(t_cur->on_time) );
	    break;
	  }
	  if(t_cur == t_n_e){  break; }
	  t_cur = t_cur->next;
	}
      }

      if(c_cur == c_n_e){  break; }
      c_cur = c_cur->next;
    }
  }



  /*  TARGET  deviation դ  */
  t_cur = t_n_s;
  c_cur = c_n_s;
  t_top_time = t_n_s->on_time.beat;

  c_n_s_pre_note = c_n_s->pre;
  while(1){
    if(c_n_s_pre_note == NULL){
      break;
    }
    if(c_n_s_pre_note->ident == NOTE){
      break;
    }
    c_n_s_pre_note = c_n_s_pre_note->pre;
  }

  if(c_n_s_pre_note != NULL){
    c_pre_vel = c_n_s_pre_note->val[ON_VEL];
  }else{
    if(pctrl.arg_default_vel > 0){
      c_pre_vel = pctrl.arg_default_vel;
    }else{
      c_pre_vel = DEFAULT_VEL;
    }
  }


  t_n_s_pre_note = t_n_s->pre;
  while(1){
    if(t_n_s_pre_note == NULL){
      break;
    }
    if(t_n_s_pre_note->ident == NOTE){
      break;
    }
    t_n_s_pre_note = t_n_s_pre_note->pre;
  }

  if(t_n_s_pre_note != NULL){
    t_pre_vel = t_n_s_pre_note->val[ON_VEL];
  }else{
    if(pctrl.arg_default_vel > 0){
      t_pre_vel = pctrl.arg_default_vel;
    }else{
      t_pre_vel = DEFAULT_VEL;
    }
  }


  while(1){
    if(c_cur == NULL){  break; }
    if( c_cur->ident == NOTE ){
      c_now_time = c_cur->on_time.beat - c_n_s->on_time.beat;

      t_cur = t_n_s;
      while(1){
	if(t_cur == NULL){  break; }
	t_now_time = t_cur->on_time.beat - t_top_time;
	if( (t_cur->ident == NOTE) && (fabs(c_now_time - t_now_time) < 0.005) ){
	  t_same = t_cur;
	  c_same = c_cur;
	  while(1){
	    printf("======\n");
	    print_node(t_same);
	    print_node(c_same);
	    printf("======\n");
	    TFcopy(&(t_same->on_diff), &(c_same->on_diff));
/* 	    TFcopy(&(t_same->len_diff), &(c_same->len_diff)); */
	    t_same->len_diff.beat = t_same->len.beat * (c_same->len_diff.beat / c_same->len.beat);
	    t_same->len_diff.meas = t_same->len.meas * (c_same->len_diff.meas / c_same->len.meas);
	    t_same->len_diff.real = t_same->len.real * (c_same->len_diff.real / c_same->len.real);


/* 	    /\*  ޤޤȤƵ䤬롥  *\/ */
/* 	    t_same->val[ON_VEL] = c_same->val[ON_VEL]; */

	    /*  ޤޤ(ICMC2005 Ѥ˺)  */
	    t_same->val[ON_VEL] = t_n_s->val[ON_VEL] * (c_same->val[ON_VEL] / c_n_s->val[ON_VEL]);

/* 	    /\*  ޤޤ  *\/ */
/* 	    t_same->val[ON_VEL] = t_n_s->val[ON_VEL] + (c_same->val[ON_VEL] - c_n_s->val[ON_VEL]); */

/* 	    if(c_n_s_pre_note != NULL){ */
/* 	      t_same->val[ON_VEL] = t_n_s->val[ON_VEL] * (c_same->val[ON_VEL] / c_n_s_pre_note->val[ON_VEL]); */
/* 	    }else{ */
/* 	      if(pctrl.arg_default_vel > 0){ */
/* 		t_same->val[ON_VEL] = t_n_s->val[ON_VEL] * (c_same->val[ON_VEL] / pctrl.arg_default_vel); */
/* 	      }else{ */
/* 		t_same->val[ON_VEL] = t_n_s->val[ON_VEL] * (c_same->val[ON_VEL] / (double)DEFAULT_VEL); */
/* 	      } */
/* 	    } */


/* /\*  ˾  *\/ */
/* 	    if(c_n_s_pre_note != NULL){ */
/* 	      t_same->val[ON_VEL] = t_n_s->val[ON_VEL] + (c_same->val[ON_VEL] - c_n_s_pre_note->val[ON_VEL]); */
/* 	    }else{ */
/* 	      if(pctrl.arg_default_vel > 0){ */
/* 		t_same->val[ON_VEL] = t_n_s->val[ON_VEL] + (c_same->val[ON_VEL] - pctrl.arg_default_vel); */
/* 	      }else{ */
/* 		t_same->val[ON_VEL] = t_n_s->val[ON_VEL] + (c_same->val[ON_VEL] - (double)DEFAULT_VEL); */
/* 	      } */
/* 	    } */

/* 	    printf("%d, %d\n", (int)c_same->val[ON_VEL], (int)c_pre_vel); */
/* 	    getchar(); */

/* 	    t_same->val[ON_VEL] = t_n_s->val[ON_VEL] + (c_same->val[ON_VEL] - c_pre_vel); */
/* 	    t_same->val[ON_VEL] = t_n_s->val[ON_VEL] * (c_same->val[ON_VEL] / c_pre_vel); */

/* 	    /\*  Х󥹤  *\/ */
/* 	    t_same->val[ON_VEL] = t_same->val[ON_VEL] * (c_same->val[ON_VEL] / c_pre_vel); */

/* 	    /\*  Х󥹤  *\/ */
/* 	    t_same->val[ON_VEL] = t_pre_vel * (c_same->val[ON_VEL] / c_pre_vel); */

/* 	    /\*  Х󥹤  *\/ */
/* 	    t_same->val[ON_VEL] = t_pre_vel + (c_same->val[ON_VEL] - c_pre_vel); */

	    if(t_same->val[ON_VEL] > 127){
	      t_same->val[ON_VEL] = 127;
	    }
	    if(t_same->val[ON_VEL] < 1){
	      t_same->val[ON_VEL] = 1;
	    }
	    t_same = t_same->samenext;
	    if(c_same->samenext != NULL){
	      c_same = c_same->samenext;
	    }
	    if(t_same == NULL){
	      break;
	    }
	  }
	  goto apply_devi_one_node_end;
	}
	if(t_cur == t_n_e){  break; }
	t_pre_vel = t_cur->val[ON_VEL];
	t_cur = t_cur->next;
      }

      c_pre_vel = c_cur->val[ON_VEL];

    }
  apply_devi_one_node_end:


    if(c_cur == c_n_e){  break; }
    c_cur = c_cur->next;
  }


  koko(7);
  puts("====== TARGET ======");
  notelist_display_fromto(t_n_s->pre, t_n_e->next);
/*   notelist_display_fromto(t_s, t_e); */

  koko(7);
/*   getchar(); */

  return;
}
