/*  Time-stamp: <2005-12-29 03:33:31 >  */
#include  "4ru.h"
#include  <glut.h>
#include  "GLcube.h"
#include  "whole.xbm"
#include  "half.xbm"
#include  "quater.xbm"
#include  "eighth.xbm"
#include  "sixteenth.xbm"
#include  "thirtysecond.xbm"
#include  "BD.xbm"
#include  "HH.xbm"


#define  Y_ADJ  1

#define  ATK_MUL 20.0

extern int win_w;
extern int win_h;
extern double camera_x;
extern double camera_y;
extern double camera_z;
extern GLuint notescreen;
extern int view_devi;
extern int view_score;
extern int disp_vel;
extern int loud_slope;
extern int note_head;
extern int disp_event;
extern int srch_x;
extern int srch_y;
extern NOTE_NODE *srch_cur;
extern int region_x;
extern int region_y;
extern PERF_CTRL pctrl;


int draw_event(NOTE_NODE *cur, double Lbot, double inter, double Velbot, double Veltop,
	       double ppqbeat, double alpha, double draw_on_time_bias, GLdouble arg_event_colors[8][4], DRUM_DEF *drum_data)
{
  /*  static ˤƤȤǡưѿݤΥХإåɤʤ®ޤ  */
  /*  ޤåΰ˴Ϳ  */
/*   static GLdouble event_base[8][3]; */
/*   static GLdouble event[8][3]; */
/*   static GLdouble devi_event[8][3]; */
/*   static GLdouble event_colors[8][4]; */
/*   static GLdouble dot[8][3]; */

  GLdouble event_base[8][3];
  GLdouble event[8][3];
  GLdouble devi_event[8][3];
  GLdouble event_colors[8][4];
  GLdouble dot[8][3];

  int linewidth;
  int atk_width;
  int atk_depth;
  int rel_width;
  int rel_depth;
  int i;
  int oct;
  int Vel_val_top;
  int Vel_val_bot;
  double qlen;
  double base_len;
  int scale_no;
  static int notehead_x_adj = -8;
  static int notehead_y_adj = -8;
  static int scale[7] = {
    5,  /*  A  */
    6,  /*  B  */
    0,  /*  C  */
    1,  /*  D  */
    2,  /*  E  */
    3,  /*  F  */
    4,  /*  G  */
  };



  atk_depth = (win_h / 127.0) * cur->val[ON_VEL];
  if(cur->val[OFF_VEL] != -1){
    rel_depth = (win_h / 127.0) * cur->val[OFF_VEL];
  }else{
    rel_depth = atk_depth;
  }
  
  if(loud_slope == OFF){
    linewidth = EVENT_WIDTH;
    atk_width = linewidth;
    rel_width = linewidth;
  }else{
    linewidth = 2;
    atk_width = linewidth * (cur->val[ON_VEL] / 127.0) * 2.0 * ATK_MUL;
    if(cur->val[OFF_VEL] != -1){
      rel_width = linewidth * (cur->val[OFF_VEL] / 127.0) * 2.0 * ATK_MUL;
    }else{
      rel_width = linewidth;
    }
  }


  memmove(event_colors, arg_event_colors, sizeof(GLdouble) * 8 * 4);

  /*  Ǥϡɽͤˡevent 礭ꤹ  */
  /*  ꤹ  */
  event_base[0][X] = 0;
  event_base[0][Y] = 0;
  event_base[0][Z] = win_h;
  
  event_base[1][X] = 0;
  event_base[1][Y] = atk_width;
  event_base[1][Z] = win_h;
  
  event_base[2][X] = cur->len.beat * ppqbeat;
  event_base[2][Y] = rel_width;
  event_base[2][Z] = win_h;
  
  event_base[3][X] = cur->len.beat * ppqbeat;
  event_base[3][Y] = 0;
  event_base[3][Z] = win_h;

  
  event_base[4][X] = 0;
  event_base[4][Y] = 0;
  event_base[4][Z] = win_h - atk_depth;
  
  event_base[5][X] = 0;
  event_base[5][Y] = atk_width;
  event_base[5][Z] = win_h  - atk_depth;
  
  event_base[6][X] = cur->len.beat * ppqbeat;
  event_base[6][Y] = rel_width;
  event_base[6][Z] = win_h - rel_depth;
  
  event_base[7][X] = cur->len.beat * ppqbeat;
  event_base[7][Y] = 0;
  event_base[7][Z] = win_h - rel_depth;


  oct = 4;

  for(i = 0; i < 8; i++){
    event[i][X] = event_base[i][X] + cur->on_time.beat * ppqbeat - draw_on_time_bias;
    event[i][Y] = event_base[i][Y] + calc_y_pos(Lbot, inter, linewidth, scale, cur, drum_data, oct, Y_ADJ);
    event[i][Z] = event_base[i][Z];
  }

  cur->draw_norm_xs = event[0][X];
  cur->draw_norm_xe = event[3][X];
  cur->draw_norm_ys = event[0][Y];
  cur->draw_norm_ye = event[3][Y];

  if(cur->xml_org_node != NULL){
    cur->xml_org_node->draw_norm_xs = event[0][X];
    cur->xml_org_node->draw_norm_xe = event[3][X];
    cur->xml_org_node->draw_norm_ys = event[0][Y];
    cur->xml_org_node->draw_norm_ye = event[3][Y];
  }

  if(cur->to_note_node != NULL){
    cur->to_note_node->draw_norm_xs = event[0][X];
    cur->to_note_node->draw_norm_xe = event[3][X];
    cur->to_note_node->draw_norm_ys = event[0][Y];
    cur->to_note_node->draw_norm_ye = event[3][Y];
  }
  
  if(view_score == ON){  /*  view_score == ON  */
    /*  Ǥϡɽꤹ(base 򤺤餹)  */
    /*  ͤΡȥʥФǤϤʤʸ󤫤  */
    /*  (եåȷϤǤͤ뤿)  */
    oct = 4;
    for(i = 1; i <= 4; i++){
      if(cur->str[0][i] == '\0'){
	oct = 4;
	break;
      }
      if(isdigit(cur->str[0][i]) != 0){
	oct = cur->str[0][i] - '0';
	break;
      }
    }

    for(i = 0; i < 8; i++){
      event[i][X] = event_base[i][X] + cur->on_time.beat * ppqbeat - draw_on_time_bias;
      event[i][Y] = event_base[i][Y] + calc_y_pos(Lbot, inter, linewidth, scale, cur, drum_data, oct, Y_ADJ);
      event[i][Z] = event_base[i][Z];
    }

    cur->draw_xs = event[0][X];
    cur->draw_xe = event[3][X];
    cur->draw_ys = event[0][Y];
    cur->draw_ye = event[3][Y];

    if(cur->xml_org_node != NULL){
      cur->xml_org_node->draw_xs = event[0][X];
      cur->xml_org_node->draw_xe = event[3][X];
      cur->xml_org_node->draw_ys = event[0][Y];
      cur->xml_org_node->draw_ye = event[3][Y];
    }
    if(cur->to_note_node != NULL){
      cur->to_note_node->draw_xs = event[0][X];
      cur->to_note_node->draw_xe = event[3][X];
      cur->to_note_node->draw_ys = event[0][Y];
      cur->to_note_node->draw_ye = event[3][Y];
    }

    if(disp_event == ON){
      glVertexPointer(3, GL_DOUBLE, 0, event);
      glColorPointer(4, GL_DOUBLE, 0, event_colors);
      glDrawElements(GL_QUADS, 24, GL_UNSIGNED_BYTE, cubeIndices);
    }

    put_sf(event[0][X], event[0][Y], event[0][Z], cur, event_colors[0]);

    disp_vel_value(event[0][X], event[0][Y], event[0][Z], event_colors[0], cur->val[ON_VEL]);
/*     disp_vel_value(event[0][X], event[0][Y], event[0][Z], event_colors[0], DEFAULT_VEL); */

    draw_vel_stair(event, Velbot, Veltop, &Vel_val_top, &Vel_val_bot, DEFAULT_VEL, -1, event_colors);
    disp_vel_value(event[0][X], Vel_val_top - 4, event[0][Z], event_colors[0], cur->val[ON_VEL]);
/*     disp_vel_value(event[0][X], Vel_val_top - 4, event[0][Z], event_colors[0], DEFAULT_VEL); */
    cur->draw_vel_stair_y = Vel_val_top;
    if(cur->xml_org_node != NULL){
      cur->xml_org_node->draw_vel_stair_y = Vel_val_top;
    }

    srch_chk(srch_x, srch_y, region_y, &srch_cur, cur, event, Vel_val_top, -1);
    /*  view_score == ON  */
  }else{
    /*  view_score != ON  */
    /*  ܷϡlen_diff ̤  */
    event_base[2][X] += cur->len_diff.beat * ppqbeat;
    event_base[3][X] += cur->len_diff.beat * ppqbeat;
    event_base[6][X] += cur->len_diff.beat * ppqbeat;
    event_base[7][X] += cur->len_diff.beat * ppqbeat;
    
    /*  Ǥϡɽꤹ(base 򤺤餹)  */
    /*  ͤΡȥʥФǤϤʤʸ󤫤  */
    /*  (եåȷϤǤͤ뤿)  */
    oct = 4;
    for(i = 1; i <= 4; i++){
      if(cur->str[0][i] == '\0'){
	oct = 4;
	break;
      }
      if(isdigit(cur->str[0][i]) != 0){
	oct = cur->str[0][i] - '0';
	break;
      }
    }

    for(i = 0; i < 8; i++){
      event[i][X] = event_base[i][X] + (cur->on_time.beat + cur->on_diff.beat) * ppqbeat
	- draw_on_time_bias;
      event[i][Y] = event_base[i][Y] + calc_y_pos(Lbot, inter, linewidth, scale, cur, drum_data, oct, Y_ADJ);
      event[i][Z] = event_base[i][Z];
    }
    
    if(disp_event == ON){
      glVertexPointer(3, GL_DOUBLE, 0, event);
      glColorPointer(4, GL_DOUBLE, 0, event_colors);
      /* 	gluQuadricDrawStyle(event, GLU_LINE); */
      glDrawElements(GL_QUADS, 24, GL_UNSIGNED_BYTE, cubeIndices);
    }
    
    cur->draw_xs = event[0][X];
    cur->draw_xe = event[3][X];
    cur->draw_ys = event[0][Y];
    cur->draw_ye = event[3][Y];
    
    if(cur->xml_org_node != NULL){
      cur->xml_org_node->draw_xs = event[0][X];
      cur->xml_org_node->draw_xe = event[3][X];
      cur->xml_org_node->draw_ys = event[0][Y];
      cur->xml_org_node->draw_ye = event[3][Y];
    }
    if(cur->to_note_node != NULL){
      cur->to_note_node->draw_xs = event[0][X];
      cur->to_note_node->draw_xe = event[3][X];
      cur->to_note_node->draw_ys = event[0][Y];
      cur->to_note_node->draw_ye = event[3][Y];
    }
    put_sf(event[0][X], event[0][Y], event[0][Z], cur, event_colors[0]);
    disp_vel_value(event[0][X], event[0][Y], event[0][Z], event_colors[0], cur->val[ON_VEL]);

    draw_vel_stair(event, Velbot, Veltop, &Vel_val_top, &Vel_val_bot, cur->val[ON_VEL], cur->val[OFF_VEL], event_colors);
    disp_vel_value(event[0][X], Vel_val_top - 4, event[0][Z], event_colors[0], cur->val[ON_VEL]);

    cur->draw_vel_stair_y = Vel_val_top;
    if(cur->xml_org_node != NULL){
      cur->xml_org_node->draw_vel_stair_y = Vel_val_top;
    }
    
    srch_chk(srch_x, srch_y, region_y, &srch_cur, cur, event, Vel_val_top, Vel_val_bot);

    /*  view_devi == ON  */
    if(view_devi == ON){
      /* on_diff ݥꥴɽ  */
      event_base[0][X] = 0;
      event_base[0][Y] = 0;
      event_base[0][Z] = win_h;
      
      event_base[1][X] = 0;
      event_base[1][Y] = atk_width;
      event_base[1][Z] = win_h;
      
      event_base[2][X] = fabs(cur->on_diff.beat) * ppqbeat;
      event_base[2][Y] = rel_width;
      event_base[2][Z] = win_h;
      
      event_base[3][X] = fabs(cur->on_diff.beat) * ppqbeat;
      event_base[3][Y] = 0;
      event_base[3][Z] = win_h;
      
      event_base[4][X] = 0;
      event_base[4][Y] = 0;
      event_base[4][Z] = win_h - atk_depth;

      event_base[5][X] = 0;
      event_base[5][Y] = atk_width;
      event_base[5][Z] = win_h  - atk_depth;
  
      event_base[6][X] = fabs(cur->on_diff.beat) * ppqbeat;
      event_base[6][Y] = rel_width;
      event_base[6][Z] = win_h - rel_depth;
      
      event_base[7][X] = fabs(cur->on_diff.beat) * ppqbeat;
      event_base[7][Y] = 0;
      event_base[7][Z] = win_h - rel_depth;
      
      for(i = 0; i < 8; i++){
	if(cur->on_diff.beat > 0.0){
	  devi_event[i][X] = event_base[i][X] + (cur->on_time.beat) * ppqbeat
	    - draw_on_time_bias;
	}else{
	  devi_event[i][X] = event_base[i][X] + (cur->on_time.beat + cur->on_diff.beat) * ppqbeat
	    - draw_on_time_bias;
	}
	devi_event[i][Y] = event_base[i][Y] + calc_y_pos(Lbot, inter, linewidth, scale, cur, drum_data, oct, Y_ADJ);
	devi_event[i][Z] = event_base[i][Z];
      }

      /*  devi   */
      for(i = 0; i < 8; i++){
	event_colors[i][R] *= 0.7;
	event_colors[i][G] *= 0.7;
	event_colors[i][B] *= 0.7;
	event_colors[i][A] = alpha;
      }

      if(disp_event == ON){
	glVertexPointer(3, GL_DOUBLE, 0, devi_event);
	glColorPointer(4, GL_DOUBLE, 0, event_colors);
	glDrawElements(GL_QUADS, 24, GL_UNSIGNED_BYTE, cubeIndices);
      }
/*       srch_chk(srch_x, srch_y, region_x, region_y, &srch_cur, cur, devi_event, Vel_val_top); */

      cur->draw_xs = event[0][X];
      cur->draw_ys = event[0][Y];

      if(cur->xml_org_node != NULL){
	cur->xml_org_node->draw_xs = event[0][X];
	cur->xml_org_node->draw_ys = event[0][Y];
      }
      if(cur->to_note_node != NULL){
	cur->to_note_node->draw_xs = event[0][X];
	cur->to_note_node->draw_ys = event[0][Y];
      }

      /* len_diff ݥꥴɽ  */
      event_base[0][X] = 0;
      event_base[0][Y] = 0;
      event_base[0][Z] = win_h;
      
      event_base[1][X] = 0;
      event_base[1][Y] = atk_width;
      event_base[1][Z] = win_h;
      
      event_base[2][X] = fabs(cur->len_diff.beat) * ppqbeat;
      event_base[2][Y] = rel_width;
      event_base[2][Z] = win_h;
      
      event_base[3][X] = fabs(cur->len_diff.beat) * ppqbeat;
      event_base[3][Y] = 0;
      event_base[3][Z] = win_h;
      
      event_base[4][X] = 0;
      event_base[4][Y] = 0;
      event_base[4][Z] = win_h - atk_depth;
      
      event_base[5][X] = 0;
      event_base[5][Y] = atk_width;
      event_base[5][Z] = win_h  - atk_depth;
      
      event_base[6][X] = fabs(cur->len_diff.beat) * ppqbeat;
      event_base[6][Y] = rel_width;
      event_base[6][Z] = win_h - rel_depth;
      
      event_base[7][X] = fabs(cur->len_diff.beat) * ppqbeat;
      event_base[7][Y] = 0;
      event_base[7][Z] = win_h - rel_depth;
      
      for(i = 0; i < 8; i++){
	if(cur->len_diff.beat > 0.0){
	  event[i][X] =
	    event_base[i][X] + (cur->on_time.beat + cur->on_diff.beat + cur->len.beat) * ppqbeat
	    - draw_on_time_bias;
	}else{
	  event[i][X] =
	    event_base[i][X] + (cur->on_time.beat + cur->on_diff.beat + cur->len.beat + cur->len_diff.beat) * ppqbeat
	    - draw_on_time_bias;
	}
	event[i][Y] = event_base[i][Y] + calc_y_pos(Lbot, inter, linewidth, scale, cur, drum_data, oct, Y_ADJ);
	event[i][Z] = event_base[i][Z];
      }

      cur->draw_xe = event[3][X];
      cur->draw_ye = event[3][Y];

      if(cur->xml_org_node != NULL){
	cur->xml_org_node->draw_xe = event[3][X];
	cur->xml_org_node->draw_ye = event[3][Y];
      }
      if(cur->to_note_node != NULL){
	cur->to_note_node->draw_xe = event[3][X];
	cur->to_note_node->draw_ye = event[3][Y];
      }

      if(disp_event == ON){
	glVertexPointer(3, GL_DOUBLE, 0, event);
	glColorPointer(4, GL_DOUBLE, 0, event_colors);
	glDrawElements(GL_QUADS, 24, GL_UNSIGNED_BYTE, cubeIndices);
      }
    }
  }

  if( (note_head == ON) && (cur->ident != REST) ){
    base_len = 0.0;
    qlen = floor(cur->len.q_time * 8) / 8;
    set_event_colors(cur->str[1], event_colors);
    /*  ɥڴ͡फɤå  */
    for(i = 0; i < DRUM_KIND; i++){
      if(strcmp(cur->str[0], (*(drum_data + i)).str) == 0){
	if((*(drum_data + i)).y_pos < 5){
	  xbm_put(cur->draw_xs -14, cur->draw_ys -50, 0, BD_width, BD_height, BD_bits, event_colors[0]);
	}else if((*(drum_data + i)).y_pos >= 10){
	  xbm_put(cur->draw_xs -8, cur->draw_ys -8, 0, HH_width, HH_height, HH_bits, event_colors[0]);
	}else{
	  xbm_put(cur->draw_xs -8, cur->draw_ys -8, 0, quater_width, quater_height, quater_bits, event_colors[0]);
	}
	goto skip_notehead;
      }
    }
    
    if( qlen >= 4.000){
      xbm_put(cur->draw_xs + notehead_x_adj, cur->draw_ys + notehead_y_adj, 0, whole_width, whole_height, whole_bits, event_colors[0]);
      base_len = 4.000;
    }else if( (4.000 > qlen) && (qlen >= 2.000) ){  /*  half  */
      xbm_put(cur->draw_xs + notehead_x_adj, cur->draw_ys + notehead_y_adj, 0, half_width, half_height, half_bits, event_colors[0]);
      base_len = 2.000;
    }else if( (2.000 > qlen) && (qlen >= 1.000) ){ /*  quater  */
      xbm_put(cur->draw_xs + notehead_x_adj, cur->draw_ys + notehead_y_adj, 0, quater_width, quater_height, quater_bits, event_colors[0]);
      base_len = 1.000;
    }else if( (1.000 > qlen) && qlen >= 0.500){  /*  eighth  */
      xbm_put(cur->draw_xs + notehead_x_adj, cur->draw_ys + notehead_y_adj, 0, eighth_width, eighth_height, eighth_bits, event_colors[0]);
      base_len = 0.500;
    }else if( (0.500 > qlen) && (qlen >= 0.250) ){  /*  16th  */
      xbm_put(cur->draw_xs + notehead_x_adj, cur->draw_ys + notehead_y_adj, 0, sixteenth_width, sixteenth_height, sixteenth_bits, event_colors[0]);
      base_len = 0.250;
    }else if( (0.250 > qlen) && (qlen >= 0.125) ){  /*  32th  */
      xbm_put(cur->draw_xs + notehead_x_adj, cur->draw_ys + notehead_y_adj, 0, thirtysecond_width, thirtysecond_height, thirtysecond_bits, event_colors[0]);
      base_len = 0.250;
    }else{
      if(pctrl.displevel >= 2){
	br_printf(6, "%s: %d: len_q_time: %5.3f\n", __FILE__, __LINE__, cur->len.q_time);
      }
    }

  skip_notehead:

    dot[0][X] = 0;
    dot[0][Y] = 0;
    dot[0][Z] = win_h;
    
    dot[1][X] = 0;
    dot[1][Y] = EVENT_DOT_SIZE;
    dot[1][Z] = win_h;
    
    dot[2][X] = EVENT_DOT_SIZE;
    dot[2][Y] = EVENT_DOT_SIZE;
    dot[2][Z] = win_h;
    
    dot[3][X] = EVENT_DOT_SIZE;
    dot[3][Y] = 0;
    dot[3][Z] = win_h;
    
    dot[4][X] = 0;
    dot[4][Y] = EVENT_DOT_SIZE;
    dot[4][Z] = win_h - atk_depth;
    
    dot[5][X] = 0;
    dot[5][Y] = EVENT_DOT_SIZE;
    dot[5][Z] = win_h  - atk_depth;
    
    dot[6][X] = EVENT_DOT_SIZE;
    dot[6][Y] = EVENT_DOT_SIZE;
    dot[6][Z] = win_h - rel_depth;
    
    dot[7][X] = EVENT_DOT_SIZE;
    dot[7][Y] = 0;
    dot[7][Z] = win_h - rel_depth;
    
    for(i = 0; i < 8; i++){
      dot[i][X] += cur->draw_xs + 14;
      dot[i][Y] += cur->draw_ys;
    }
    scale_no = scale[toupper(cur->str[0][0]) - 'A']; 
    if( ((int)floor(cur->val[NOTE_NO]) % 24) >= 12){
      if( (scale_no % 2) == 0 ){
	for(i = 0; i < 8; i++){
	  dot[i][Y] += (inter / 2.0);
	}
      }
    }else{
      if( (scale_no % 2) != 0 ){
	for(i = 0; i < 8; i++){
	  dot[i][Y] += (inter / 2.0);
	}
      }
    }
    
    
    if( eq(qlen, base_len * 1.5) ){  /*    */
      glVertexPointer(3, GL_DOUBLE, 0, dot);
      glColorPointer(4, GL_DOUBLE, 0, event_colors);
      glDrawElements(GL_QUADS, 24, GL_UNSIGNED_BYTE, cubeIndices);
    }else if( eq(qlen, base_len * 1.75) ){  /*  ʣ  */
      glVertexPointer(3, GL_DOUBLE, 0, dot);
      glColorPointer(4, GL_DOUBLE, 0, event_colors);
      glDrawElements(GL_QUADS, 24, GL_UNSIGNED_BYTE, cubeIndices);
      
      for(i = 0; i < 8; i++){
	dot[i][X] += (EVENT_DOT_SIZE * 2);
      }
      glVertexPointer(3, GL_DOUBLE, 0, dot);
      glColorPointer(4, GL_DOUBLE, 0, event_colors);
      glDrawElements(GL_QUADS, 24, GL_UNSIGNED_BYTE, cubeIndices);
      
    }
  }

/*   if(event[0][X] > (win_w + 100)){ */
/*     return !EXIT_SUCCESS; */
/*   }else{ */
/*     return EXIT_SUCCESS; */
/*   } */

  return event[0][X];

}
