#include  "4ru.h"

extern int win_w;

/*  GPR3 change
    GPR3d articulation  */
int gpr3d(NOTE_NODE *linetop)
{
  NOTE_NODE *cur;
  NOTE_NODE *n[4];
  double len1;
  double len2;
  double len3;
  double len4;
  double len12_bias;
  double len23_bias;
  double len34_bias;


  cur = linetop;

  while(1){
    if(cur->draw_xs >= (win_w + 128) ){  return  EXIT_SUCCESS; }
    len12_bias = 0.0;
    len23_bias = 0.0;
    len34_bias = 0.0;

    if(get_n4(cur, n, -1) == EXIT_FAILURE){  return  EXIT_SUCCESS;  }
    /*
      n1 : n[0]
      n2 : n[1]
      n3 : n[2]
      n4 : n[3]
    */

    len1 = n[0]->len.beat;
    len2 = n[1]->len.beat;
    len3 = n[2]->len.beat;
    len4 = n[3]->len.beat;

    n[1]->GPR[GPR3d] = fabs(((len1 + len2) / 2.0) - ((len3 + len4) / 2.0));

    if( (fabs(len2 - len3) > len23_bias) &&
	(fabs(len1 - len2) <= len12_bias) &&
	(fabs(len3 - len4) <= len34_bias) ){
      n[1]->GPR_ON_OFF[GPR3d] = ON;
    }else{
      n[1]->GPR_ON_OFF[GPR3d] = OFF;
/*       n[1]->GPR[GPR3d] = 0;  /\*  koko  *\/ */
    }

    if(n[1]->org_node != NULL){
      n[1]->org_node->GPR[GPR3d] = n[1]->GPR[GPR3d];
      n[1]->org_node->GPR_ON_OFF[GPR3d] = n[1]->GPR_ON_OFF[GPR3d];
    }

    cur = cur->next;
  }

  return  EXIT_SUCCESS;
}
