/*  Time-stamp: <2005-04-13 21:48:26 >  */
#ifndef MIDI_IO_H
#define MIDI_IO_H

#include  <stdio.h>
#include  <stdlib.h>
#include  <signal.h>
#include  <unistd.h>

#ifdef CYGWIN
#include  <windows.h>
#include  <mmsystem.h>
#endif

#ifdef  OSX
#include  <CoreMIDI/CoreMIDI.h>
/*  #include  <CoreMIDI/MIDIServices.h> */
#include  <CoreAudio/HostTime.h>
/*  #include  <CoreFoundation/CFRunLoop.h> */
#endif

#ifdef OSX
#define  CALLBACK
#define  UINT  UInt32
#define  DWORD UInt64
#define  WORD UInt32
#endif

#ifdef  LINUX
#define  CALLBACK
#define  UINT  unsigned int
#define  DWORD int
#define  WORD  int
#endif


#include  "disp_ctr.h"
#include  "SMFrw.h"


#define  DEFAULT_QBPM 120.0

#define  STRBUFLEN  1024

#define  COUNTER_STOP 1
#define  COUNTER_START 0

#ifdef CYGWIN
#define _1_MSEC 1000.0
#else
#define _1_MSEC 10000.0
#endif

#ifdef CYGWIN
#define  DEFAULT_MIDI_OUT_PORT  MIDI_MAPPER
#else  /*  Mac OS X p`  */
#define  DEFAULT_MIDI_OUT_PORT  0
#endif

#define  PORT_NUM_BUFSIZE  256
#define  NOT_PORT_NO -16

#ifndef ON
#define ON 1
#endif

#ifndef OFF
#define OFF !ON
#endif

#ifndef START
#define  START ON
#endif

#ifndef STOP
#define  STOP OFF
#endif

/*  MIDI I/O n  */
int get_midi_out_num(int *out_num);
int select_midi_out(void);
int open_midi_out(int out_port);
int close_midi_out(int out_port);

void midi_out(int time, int stat, int val1, int val2, int *vals);

#ifdef  CYGWIN
void CALLBACK midi_in(HMIDIIN MIDI_in_Handle, UINT Msg, DWORD Instance, DWORD Para1, DWORD Para2);
#endif
#ifdef OSX
void midi_in(const MIDIPacketList *pktlist, void *refCon, void *connRefCon);
#endif
#ifdef  LINUX
void midi_in(int intarg);
#endif
int select_midi_in(void);
int open_midi_in(int arg_in_port);
int close_midi_in(int arg_in_port);
char *get_midi_in_name(int port);
void close_midi_in_all(void);



/*  counter n  */
double get_counter(void);

#ifdef  CYGWIN
void CALLBACK count_up(UINT timerID, UINT uMsg, DWORD dwUser, DWORD dw1, DWORD dw2);
#define  RET
#else  /*  OS X  */
void count_up(int intarg);
#define  RET   EXIT_SUCCESS
#endif

int init_counter_tick_up(double qbpm, double init_counter_val);

void start_counter(void);

void stop_counter(void);

int close_counter(void);

void calc_BPM_int_tick(double  qbpm);

void calc_BEATTIME_int_tick(double  beattime);

char *get_midi_out_name(int port);

void midi_exit(int dummy);

void close_midi_out_all(void);

void set_tempo_usec(double tempo_usec);

void set_event_str(EL **cur);

#endif
