#include  "xml2note.h"


xmlNode *notations_analyze(xmlNode *cur, NOTE_NODE **part_cur)
{
  int inttmp;
  xmlChar xmlchartmp[STR_LEN];
  int slur_idx;
  int gliss_idx;
  char str_buf[STR_LEN];


  if(cur->children == NULL){
    return  cur;
  }

  slur_idx = 0;
  gliss_idx = 0;

  cur = cur->children;      /*  now: cur == "notations" ̂ЂƂ  */
  while(1){
    if(xmlStrcmp(cur->name, (const xmlChar *)"tied") == 0){
      /* <duration> ̒ɕK <tie> 悤Ȃ̂ŁC<notations>  <tied> ͖D*/
      /*
	<!ELEMENT tied EMPTY>
	<!ATTLIST tied
	type %start-stop; #REQUIRED
	number %beam-level; #IMPLIED
	%line-type;
	%position;
	%placement;
	%orientation;
	>
      */
      ;
    }else if(xmlStrcmp(cur->name, (const xmlChar *)"slur") == 0){
      /*
	<!ELEMENT slur EMPTY>
	<!ATTLIST slur
	type %start-stop-continue; #REQUIRED
	number %beam-level; "1"
	%line-type;
	%position;
	%placement;
	%orientation;
	%bezier;
	>
      */
      while(1){
	if(slur_idx >= SLUR_NUM){
	  sprintf(str_buf, "NOTEfile.h  SLUR_NUM  %d 傫ȒlɂčăRpCĂD\n",
		   SLUR_NUM);
	  disp_err(str_buf);
	  disp_err("X[i[郁܂D\n");
	  exit(EXIT_FAILURE);
	}

	if( (*part_cur)->notations.slur[slur_idx].type == NO_INFO){
	  break;
	}
	slur_idx++;
      }

      if(xmlGetProp(cur, "type") != NULL){
	sscanf(xmlGetProp(cur, "type"), "%s", xmlchartmp);
	(*part_cur)->xml_len_diff.beat = 0.0;
	(*part_cur)->xml_len_diff.meas = 0.0;

	if(strcmp(xmlchartmp, "start") == 0){
	  (*part_cur)->notations.slur[slur_idx].type = START;
	}else if(strcmp(xmlchartmp, "stop") == 0){
	  (*part_cur)->notations.slur[slur_idx].type = STOP;
	}else if(strcmp(xmlchartmp, "continue") == 0){
	  (*part_cur)->notations.slur[slur_idx].type = CONT;
	}
      }
      
      if(xmlGetProp(cur, "number") != NULL){
	sscanf(xmlGetProp(cur, "number"), "%d", &inttmp);
	(*part_cur)->notations.slur[slur_idx].number = inttmp;
      }
      
      if(xmlGetProp(cur, "line-type") != NULL){
	strcpy((*part_cur)->notations.slur[slur_idx].linetype, xmlGetProp(cur, "line-type"));
      }
      
      if(xmlGetProp(cur, "default-x") != NULL){
	sscanf(xmlGetProp(cur, "default-x"), "%d", &inttmp);
	(*part_cur)->notations.slur[slur_idx].pos.def_x = inttmp;
      }
      
      if(xmlGetProp(cur, "default-y") != NULL){
	sscanf(xmlGetProp(cur, "default-y"), "%d", &inttmp);
	(*part_cur)->notations.slur[slur_idx].pos.def_y = inttmp;
      }
      
      if(xmlGetProp(cur, "relative-x") != NULL){
	sscanf(xmlGetProp(cur, "relative-x"), "%d", &inttmp);
	(*part_cur)->notations.slur[slur_idx].pos.rel_x = inttmp;
      }
      
      if(xmlGetProp(cur, "relative-y") != NULL){
	sscanf(xmlGetProp(cur, "relative-x"), "%d", &inttmp);
	(*part_cur)->notations.slur[slur_idx].pos.rel_y = inttmp;
      }
      
      if(xmlGetProp(cur, "placement") != NULL){
	strcpy((*part_cur)->notations.slur[slur_idx].place, xmlGetProp(cur, "placement"));
      }
      
      if(xmlGetProp(cur, "orientation") != NULL){
	strcpy((*part_cur)->notations.slur[slur_idx].orient, xmlGetProp(cur, "orientation"));
      }
      
      if(xmlGetProp(cur, "bezier-offset") != NULL){
	sscanf(xmlGetProp(cur, "bezier-offset"), "%d", &inttmp);
	(*part_cur)->notations.slur[slur_idx].bz_offset = inttmp;
      }
      
      if(xmlGetProp(cur, "bezier-offset2") != NULL){
	sscanf(xmlGetProp(cur, "bezier-offset2"), "%d", &inttmp);
	(*part_cur)->notations.slur[slur_idx].bz_offset2 = inttmp;
      }
      
      if(xmlGetProp(cur, "bezier-x") != NULL){
	sscanf(xmlGetProp(cur, "bezier-x"), "%d", &inttmp);
	(*part_cur)->notations.slur[slur_idx].bz_x = inttmp;
      }
      
      if(xmlGetProp(cur, "bezier-y") != NULL){
	sscanf(xmlGetProp(cur, "bezier-y"), "%d", &inttmp);
	(*part_cur)->notations.slur[slur_idx].bz_y = inttmp;
      }
      
      if(xmlGetProp(cur, "bezier-x2") != NULL){
	sscanf(xmlGetProp(cur, "bezier-x2"), "%d", &inttmp);
	(*part_cur)->notations.slur[slur_idx].bz_x2 = inttmp;
      }
      
      if(xmlGetProp(cur, "bezier-y2") != NULL){
	sscanf(xmlGetProp(cur, "bezier-y2"), "%d", &inttmp);
	(*part_cur)->notations.slur[slur_idx].bz_y2 = inttmp;
      }
    }else if(xmlStrcmp(cur->name, (const xmlChar *)"tuplet") == 0){
      /*
	<!ELEMENT tuplet (tuplet-actual?, tuplet-normal?)>
	<!ATTLIST tuplet
	type %start-stop; #REQUIRED
	number %beam-level; #IMPLIED
	bracket %yes-no; #IMPLIED
	show-number (actual | both | none) #IMPLIED
	show-type (actual | both | none) #IMPLIED
	%position;
	%placement;
	>
	<!ELEMENT tuplet-actual (tuplet-number?,
	tuplet-type?, tuplet-dot*)>
	<!ELEMENT tuplet-normal (tuplet-number?,
	tuplet-type?, tuplet-dot*)>
	<!ELEMENT tuplet-number (#PCDATA)>
	<!ELEMENT tuplet-type (#PCDATA)>
	<!ELEMENT tuplet-dot EMPTY>
      */
      ;
    }else if(xmlStrcmp(cur->name, (const xmlChar *)"glissando") == 0){
      /*
	<!ELEMENT glissando EMPTY>
	<!ATTLIST glissando
	type %start-stop; #REQUIRED
	number %beam-level; "1"
	%line-type; 
	%position; 
	>
      */

      while(1){
	if(gliss_idx >= GLISS_NUM){
	  sprintf(str_buf, "NOTEfile.h  GLISS_NUM  %d 傫ȒlɂčăRpCĂD\n",
		  GLISS_NUM);
	  disp_err(str_buf);
	  disp_err("ObThi[郁܂D\n");
	  exit(EXIT_FAILURE);
	}

	if( (*part_cur)->notations.gliss[gliss_idx].type == NO_INFO){
	  break;
	}
	gliss_idx++;
      }

      if(xmlGetProp(cur, "type") != NULL){
	sscanf(xmlGetProp(cur, "type"), "%s", xmlchartmp);
	if(strcmp(xmlchartmp, "start") == 0){
	  (*part_cur)->notations.gliss[gliss_idx].type = START;
	}else if(strcmp(xmlchartmp, "stop") == 0){
	  (*part_cur)->notations.gliss[gliss_idx].type = STOP;
	}else if(strcmp(xmlchartmp, "continue") == 0){
	  (*part_cur)->notations.gliss[gliss_idx].type = CONT;
	}
      }
    }else if(xmlStrcmp(cur->name, (const xmlChar *)"technical") == 0){
      cur = cur->children;  /*  now: cur == "technical" ̂ЂƂ  */
      while(cur != NULL){
	if(cur->type == XML_ELEMENT_NODE){
	  strcpy((*part_cur)->notations.tech.name, cur->name);
	  sscanf(cur->children->content, "%d", &((*part_cur)->notations.tech.val));
	  if(xmlGetProp(cur, "type") != NULL){
	    strcpy((*part_cur)->notations.tech.place, xmlGetProp(cur, "placement"));
	  }
	  break;
	}else{
	  cur = cur->next;
	}
      }
      cur = cur->parent;  /*  now: cur == "technical"  */
    }else if(xmlStrcmp(cur->name, (const xmlChar *)"articulations") == 0){
      cur = cur->children;  /*  now: cur == "articulations" ̂ЂƂ  */
      cur = cur->next;
      strcpy((*part_cur)->notations.artic.name, cur->name);
      if(xmlGetProp(cur, "type") != NULL){
	strcpy((*part_cur)->notations.artic.place, xmlGetProp(cur, "placement"));
      }
      cur = cur->parent;  /*  now: cur == "articulations"  */

    }else{
	;
    }
    
    if(cur->next == NULL){
      break;
    }
    cur = cur->next;
  }

  cur = cur->parent;      /*  now: cur == "notations"  */

  return  cur;
}
/*
<!ELEMENT notations
	((tied | slur | tuplet | glissando | slide | 
	  ornaments | technical | articulations | dynamics |
	  fermata | arpeggiate | non-arpeggiate | 
	  other-notation)*)>
<!ATTLIST notations
    editorial-level CDATA #IMPLIED
>


slide
ornaments
dynamics
fermata
arpeggiate 
non-arpeggiate | 
 other-notation

<!ATTLIST notations
    editorial-level CDATA #IMPLIED
>



*/
